/*;------------------------------------------------------------------------------
; UART-PC display routines for Lab 4 and 5
;------------------------------------------------------------------------------
*/
        #include <p30f6011.h>
		#include "UART_display.h"

//;Initialize UART port to communicate with the PC for display

void UART_Display_Setup(void){
		U1MODE = 0xA000; 	// Enable UART, 8 bits, 1 stop, no parity
		U1STA = 0x8400; 	// Enable transmitter, receiver, normal modes
		U1BRG = (unsigned int)(((unsigned long)OSCILLATOR/(16*(unsigned long)BAUD_RATE))-1);
		}

/* ;------------------------------------------------------------------------------
;Write array contents to PC through UART
*/

void UART_Display(unsigned int num_bytes,int array_ptr[]){
		unsigned int i = 0, k;
		unsigned char j;
//		UART_PutChar(0);					// Send out start of packet delimiter
//		UART_PutChar(num_bytes);			// Send out the number of bytes in the array
//		UART_PutChar(num_bytes>>8);
		while(i < num_bytes){
			j = (unsigned char)array_ptr[i++];
			if(j == 0)
				j = 1;
			UART_PutChar(j);
			}
		k = 12500;
		while(k--);					// Delay for 50 mS
		}

void UART_PutChar(unsigned char i){
	while(U1STAbits.UTXBF);		// Spin lock waiting for buffer to be empty
	U1TXREG = i;				// Send character
	}
		
/*
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*/



