; ..............................................................................
;    File   fir_test1.s
; ..............................................................................

		.equ fir_test1NumTaps, 49

; ..............................................................................
; Allocate and initialize filter taps

		.section .xdata, data, xmemory
		.align 128

fir_test1Taps:
.hword 	0xFF6C,	0xFEE0,	0xFE72,	0xFE34,	0xFE34,	0xFE78,	0xFEFE,	0xFFBA,	0x0097
.hword 	0x017C,	0x0249,	0x02DD,	0x031A,	0x02E8,	0x023A,	0x010C,	0xFF69,	0xFD66
.hword 	0xFB24,	0xF8CD,	0xF68E,	0xF495,	0xF30B,	0xF210,	0x68B2,	0xF210,	0xF30B
.hword 	0xF495,	0xF68E,	0xF8CD,	0xFB24,	0xFD66,	0xFF69,	0x010C,	0x023A,	0x02E8
.hword 	0x031A,	0x02DD,	0x0249,	0x017C,	0x0097,	0xFFBA,	0xFEFE,	0xFE78,	0xFE34
.hword 	0xFE34,	0xFE72,	0xFEE0,	0xFF6C

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 128

fir_test1Delay:
		.space fir_test1NumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _fir_test1Filter

_fir_test1Filter:
.hword fir_test1NumTaps
.hword fir_test1Taps
.hword fir_test1Taps+fir_test1NumTaps*2-1
.hword 0xff00
.hword fir_test1Delay
.hword fir_test1Delay+fir_test1NumTaps*2-1
.hword fir_test1Delay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_BlockFIRFilter
;		.extern	_fir_test1Filter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 4)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_fir_test1Filter, W0	; Initalize W0 to filter structure
;		call	_FIRFilterInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _BlockFIRFilter
;		mov	#_fir_test1Filter, W0	; Initalize W0 to filter structure
;		mov	#input, W1	; Initalize W1 to input buffer 
;		mov	#output, W2	; Initalize W2 to output buffer
;		mov	#20, W3	; Initialize W3 with number of required output samples
;		call	_BlockFIRFilter	; call as many times as needed
